/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * MusicBoxApp.java
 */
package musicbox.backend;

import musicbox.gui.MusicBoxView;
import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

/**
 * The main class of the application.
 */
public class MusicBoxApp extends SingleFrameApplication 
{

    /**
     * At startup create and show the main frame of the application.
     */
    @Override
    protected void startup() 
    {
        show(new MusicBoxView(this));
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     * @param root
     */
    @Override
    protected void configureWindow(java.awt.Window root) 
    {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of MusicBoxApp
     */
    public static MusicBoxApp getApplication() 
    {
        return Application.getInstance(MusicBoxApp.class);
    }

    /**
     * Main method launching the application.
     * @param args
     */
    public static void main(final String[] args) 
    {
        //launch(MusicBoxApp.class, args);
        java.awt.EventQueue.invokeLater(new Runnable() 
        {

            @Override
            public void run() 
            {
                launch(MusicBoxApp.class, args);
            }
        });
    }
}


