/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package musicbox.backend;

import java.io.IOException;
import java.io.ObjectOutputStream;
import musicbox.gui.MusicBoxView;
import noTalent.SocketObject;

/**
 *
 * @author Isaac Hammmon
 */
public class SocketWriteThread extends Thread 
{
    private ObjectOutputStream oos;
    private SocketObject so;
    private MusicBoxView mbv;
    
    public SocketWriteThread(ObjectOutputStream oos, SocketObject so, MusicBoxView mbv)
    {
        this.oos = oos;
        this.so = so;
        this.mbv = mbv;
    }
    
    @Override
    public void run()
    {
        try 
        {
            oos.writeObject(so);
            oos.flush();
        } 
        catch (IOException ex) 
        {
            mbv.showErrorDialog(ex);
        }
    }
}
