/*
    Music Box
    Copyright (C) 2009-2012  Isaac Hammon

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    */

package musicbox.backend.comparators;


import java.util.Comparator;
import noTalent.MusicOutputDesign;

/**
 *
 * @author Isaac Hammon
 */
public class ArtistComparator implements Comparator<MusicOutputDesign> 
{
    /**
     *
     */
    public ArtistComparator()
    {
        
    }
    
    public int compare(MusicOutputDesign m1, MusicOutputDesign m2)
    {
        if(m1.getTrackNumber().equals(""))
            return -1;
        else if(m2.getTrackNumber().equals(""))
            return 1;
        if(m1.getTrackNumber().contains("/"))
            m1.setTrackNumber(m1.getTrackNumber().substring(0, m1.getTrackNumber().indexOf("/")));
        if(m2.getTrackNumber().contains("/"))
            m2.setTrackNumber(m2.getTrackNumber().substring(0, m2.getTrackNumber().indexOf("/")));
        int num1 = Integer.parseInt(m1.getTrackNumber());
        int num2 = Integer.parseInt(m2.getTrackNumber());
        if(m1.getArtist().compareToIgnoreCase(m2.getArtist()) < 0)
        {
            return -1;
        }
        if(m1.getArtist().compareToIgnoreCase(m2.getArtist()) == 0)
        {
            if(m1.getAlbum().compareToIgnoreCase(m2.getAlbum()) < 0)
                return -1;
            else if(m1.getAlbum().compareToIgnoreCase(m2.getAlbum()) == 0)
            {
                if(num1 < num2)
                    return -1;
                else
                    return 1;
            }
            else if(m1.getAlbum().compareToIgnoreCase(m2.getAlbum()) > 0)
                return 1;
        }
        return 1;
    }
    /*public int compare(String artist1, String artist2)
    {
        return artist1.compareTo(artist2);
    }*/

    @Override
    public boolean equals(Object obj)
    {
        if(obj.getClass().toString().compareTo("ArtistComparator") == 0)
            return true;
        else
            return false;
    }
}