/*
    Music Box
    Copyright (C) 2009-2012  Isaac Hammon

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    */
package musicbox.backend.comparators;

import java.util.Comparator;
import noTalent.MusicOutputDesign;

/**
 *
 * @author Isaac Hammon
 */
public class PlayCountComparator implements Comparator<MusicOutputDesign> {
    /**
     *
     */
    public PlayCountComparator()
    {
        
    }
    @Override
    public int compare(MusicOutputDesign m1, MusicOutputDesign m2){
        int num1 = Integer.parseInt(m1.getPlayCount());
        int num2 = Integer.parseInt(m2.getPlayCount());
        if(num1 < num2)
            return -1;
        else if(num1 == num2)
            return 0;
        else
            return 1;

    }

    @Override
    public boolean equals(Object obj){
        if(obj.getClass().toString().compareTo("PlayCountComparator") == 0)
            return true;
        else
            return false;
    }
}