/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package musicbox.backend.filefilters;

import java.io.File;
import java.io.FilenameFilter;

/**
 *
 * @author Isaac Hammon
 */
public class ImageFilter implements FilenameFilter 
{

    /**
     *
     */
    public ImageFilter() 
    {
    }

    /**
     * Select only image files.
     *
     * @param dir the directory in which the file was found.
     *
     * @param name the name of the file
     *
     * @return true if and only if the name should be
     * included in the file list; false otherwise.
     */
    @Override
    public boolean accept(File dir, String name) 
    {
        if (new File(dir, name).isDirectory()) 
        {
            return false;
        }
        name = name.toLowerCase();
        return name.endsWith(".jpg") || name.endsWith(".gif") || name.endsWith(".bmp") || name.endsWith(".png")
            || name.endsWith(".tiff") || name.endsWith(".tif");
    }
}
