/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package musicbox.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;

/**
 *
 * @author Isaac Hammon
 */
public class CustomButtonHandler implements ActionListener 
{

    private MusicBoxView mbv;

    public CustomButtonHandler(MusicBoxView mbv) 
    {
        this.mbv = mbv;
    }

    @Override
    public void actionPerformed(ActionEvent e) 
    {
        if(e.getSource() instanceof JButton)
        {
            String name = ((JButton)e.getSource()).getName();
            if(name.equals("playButton"))
            {
                mbv.play();
            }
            else if (name.equals("pauseButton")) 
            {
                try 
                {
                    mbv.pause();
                } 
                catch (Exception ex) 
                {
                    mbv.showErrorDialog(ex);
                }
            }
            else if(name.equals("stopButton"))
            {
                mbv.stop();
            }
            else if(name.equals("previousTrackButton"))
            {
                mbv.previous();
            }
            else if(name.equals("nextTrackButton"))
            {
                mbv.next();
            }
            else if(name.equals("shuffleButton"))
            {
                mbv.shuffle();
            }
            else if(e.getSource() == mbv.jButton7)
            {
                mbv.nextGoogleImage();
            }
            else if(e.getSource() == mbv.jButton8)
            {
                mbv.previousGoogleImage();
            }
        }
    }
}
