/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package musicbox.gui;

import java.awt.Image;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.ImageIcon;
import javax.swing.JLabel;

/**
 *
 * @author Isaac Hammon
 */
public class CustomMouseAdapter extends MouseAdapter 
{
    private MusicBoxView mbv;
    public CustomMouseAdapter(MusicBoxView mbv) 
    {
        this.mbv = mbv;
    }

    @Override
    public void mouseEntered(MouseEvent e) 
    {
        Object o = e.getSource();
        if (o instanceof JLabel) 
        {
            JLabel currentLabel = (JLabel) o;
            ImageIcon tt = (ImageIcon) currentLabel.getIcon();
            Image i = tt.getImage();
            Image jI = i.getScaledInstance(130, 125, Image.SCALE_SMOOTH);
            mbv.showSmallAlbumArt(new ImageIcon(jI), currentLabel.getToolTipText(), currentLabel.getLocationOnScreen(), currentLabel);
        }
    }
}
