/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR v PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package musicbox.gui;

import java.awt.event.MouseEvent;
import javax.swing.JTable;
import javax.swing.table.TableModel;

/**
 *
 * @author Isaac Hammon
 */
public class CustomTable extends JTable {

    public CustomTable(TableModel tm) 
    {
        super(tm);
        /*CustomTableListener cstl = new CustomTableListener();
        this.addKeyListener(cstl);
        this.addMouseListener(cstl);
        this.addMouseMotionListener(cstl);*/
        this.setTableHeader(new CustomTableHeader(this));
        this.setAutoCreateColumnsFromModel(true);
        //TableRowSorter<CustomTableModel> sorter = new TableRowSorter<CustomTableModel>((CustomTableModel)tm);
        //this.setRowSorter(sorter);
    }
    @Override
    public String getToolTipText(MouseEvent e) 
    {
        int row = rowAtPoint(e.getPoint());
        if(row != -1)
        {
            String retVal = "<HTML>";
            retVal += "Track Title: " + getValueAt(row, getColumnModel().getColumnIndex("Track Title")) + "<BR />";
            retVal += "Artist: " + getValueAt(row, getColumnModel().getColumnIndex("Artist")) + "<BR />";
            retVal += "Album: " + getValueAt(row, getColumnModel().getColumnIndex("Album"));
            retVal +="</HTML>";
            return retVal;
        }
        else
        {
            return null;
        }
    }

    public Object getValueAt(int row, int column)
    {
        return super.getValueAt(row, this.convertColumnIndexToView(column));
    }

}
