/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR v PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package musicbox.gui;

import java.awt.Cursor;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import javax.swing.JTable;
import javax.swing.RowSorter.SortKey;
import javax.swing.SortOrder;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableRowSorter;

/**
 *
 * @author Isaac Hammon
 */
public class CustomTableHeader extends JTableHeader
{

    JTable jT;
    boolean artistClicked;
    boolean albumClicked;
    public CustomTableHeader(JTable jt) 
    {
        super(jt.getColumnModel());
        this.jT = jt;
        setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
        setResizingAllowed(true);
        artistClicked = false;
        albumClicked = false;
        this.addMouseListener(new MouseAdapter() 
        {
            @Override
            public void mouseClicked(MouseEvent e) 
            {
                int columnAtPoint = columnAtPoint(e.getPoint());
                if(jT.getColumnName(columnAtPoint).equals("Artist"))
                {
                    ArrayList<SortKey> al = new ArrayList<SortKey>();
                    if(!artistClicked)
                    {
                        al.add(new SortKey(columnAtPoint,SortOrder.DESCENDING));
                        al.add(new SortKey(jT.getColumn("Album").getModelIndex(),SortOrder.ASCENDING));
                        al.add(new SortKey(jT.getColumn("Track Number").getModelIndex(),SortOrder.ASCENDING));
                        artistClicked = true;
                    }
                    else
                    {
                        al.add(new SortKey(columnAtPoint,SortOrder.ASCENDING));
                        al.add(new SortKey(jT.getColumn("Album").getModelIndex(),SortOrder.ASCENDING));
                        al.add(new SortKey(jT.getColumn("Track Number").getModelIndex(),SortOrder.ASCENDING));
                        artistClicked = false;
                    }
                     ((TableRowSorter<CustomTableModel>)jT.getRowSorter()).setSortKeys(al);
                     ((TableRowSorter<CustomTableModel>)jT.getRowSorter()).sort();
                }
                else if(jT.getColumnName(columnAtPoint).equals("Album"))
                {
                    ArrayList<SortKey> al = new ArrayList<SortKey>();
                    if(!albumClicked)
                    {
                        al.add(new SortKey(jT.getColumn("Album").getModelIndex(),SortOrder.DESCENDING));
                        al.add(new SortKey(jT.getColumn("Artist").getModelIndex(),SortOrder.ASCENDING));
                        al.add(new SortKey(jT.getColumn("Track Number").getModelIndex(),SortOrder.ASCENDING));
                        albumClicked = true;
                    }
                    else
                    {
                        al.add(new SortKey(jT.getColumn("Album").getModelIndex(),SortOrder.ASCENDING));
                        al.add(new SortKey(jT.getColumn("Artist").getModelIndex(),SortOrder.ASCENDING));
                        al.add(new SortKey(jT.getColumn("Track Number").getModelIndex(),SortOrder.ASCENDING));
                        albumClicked = false;
                    }
                    ((TableRowSorter<CustomTableModel>)jT.getRowSorter()).setSortKeys(al);
                    ((TableRowSorter<CustomTableModel>)jT.getRowSorter()).sort();
                }
            }
        });
    }

//    @Override
//    public void processMouseMotionEvent(MouseEvent e){
//        super.processMouseMotionEvent(e);
//        //super.getColumnModel().
//        if(e.getID() == MouseEvent.MOUSE_DRAGGED){
//            TableColumn c = super.getDraggedColumn();
//        System.out.println((String)c.getIdentifier());
//        //c.setModelIndex(super.getTable().get);
//        System.out.println("Model Index: " + c.getModelIndex());
//        System.out.println("Column at point:" + super.getTable().getTableHeader().columnAtPoint(e.getPoint()) + "\n\n");
//        }
//    }
}
