/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR v PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package musicbox.gui;

import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.table.DefaultTableModel;
import noTalent.MusicOutputDesign;

/**
 *
 * @author Isaac Hammon
 */
public class CustomTableModel extends DefaultTableModel 
{

    public CustomTableModel(String[] columnNames1, int size) 
    {
        super(columnNames1, size);
    }
    public CustomTableModel()
    {
        super();
    }
    
    @Override
    public Class getColumnClass(int columnIndex) 
    {
        if (columnIndex == findColumn("Rating")) 
        {
            return ImageIcon.class;
        }
        else if(columnIndex == findColumn("Track Number") || columnIndex == findColumn("Play Count"))
        {
            return Integer.class;
        }
        else 
        {
            return String.class;
        }
    }

    public void removeAllRows()
    {
        int numRows = getRowCount();
        for(int i = 0; i < numRows; i++)
        {
            removeRow(0);
        }
    }

    public Vector getColumnIdentifiers()
    {
        return columnIdentifiers;
    }
    
    public void addRow(MusicOutputDesign mod, MusicBoxView mbv)
    {
        addRow(new Object[]{mod.getTrackNumber(), mod.getTrackTitle(), mod.getArtist(), mod.getAlbum(),
                    mod.getTrackLength(), mod.getPlayCount(), mbv.smileys[Integer.parseInt(mod.getRating())]});
    }
}
