/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * DirChooser.java
 *
 * Created on Aug 15, 2009, 5:23:49 PM
 */
package musicbox.gui;

import java.io.File;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.DefaultListModel;
import javax.swing.SwingUtilities;
import noTalent.MusicOutputDesign;

/**
 *
 * @author Isaac Hammon
 */
public class DirChooser extends javax.swing.JDialog 
{

    /**
     *
     */
    public File file;
    /**
     *
     */
    protected boolean wait;
    public MusicBoxView mbv;

    /** Creates new form DirChooser
     * @param parent
     */
    public DirChooser(java.awt.Frame parent, MusicBoxView mbv) 
    {
        super(parent);
        this.mbv = mbv;
        initComponents();
        this.setIconImage(mbv.musicBoxIcon16.getImage());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jDialog1 = new javax.swing.JDialog();
        jFrame1 = new javax.swing.JFrame();
        jPanel1 = new javax.swing.JPanel();
        jFileChooser1 = new javax.swing.JFileChooser();

        jDialog1.setName("jDialog1"); // NOI18N

        javax.swing.GroupLayout jDialog1Layout = new javax.swing.GroupLayout(jDialog1.getContentPane());
        jDialog1.getContentPane().setLayout(jDialog1Layout);
        jDialog1Layout.setHorizontalGroup(
            jDialog1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        jDialog1Layout.setVerticalGroup(
            jDialog1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );

        jFrame1.setName("jFrame1"); // NOI18N

        javax.swing.GroupLayout jFrame1Layout = new javax.swing.GroupLayout(jFrame1.getContentPane());
        jFrame1.getContentPane().setLayout(jFrame1Layout);
        jFrame1Layout.setHorizontalGroup(
            jFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        jFrame1Layout.setVerticalGroup(
            jFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N
        setResizable(false);

        jPanel1.setName("jPanel1"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(musicbox.backend.MusicBoxApp.class).getContext().getResourceMap(DirChooser.class);
        jFileChooser1.setDialogTitle(resourceMap.getString("jFileChooser1.dialogTitle")); // NOI18N
        jFileChooser1.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);
        jFileChooser1.setName("jFileChooser1"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jFileChooser1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jFileChooser1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFileChooser1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                importMusic(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     *
     * @param evt
     */
    public void importMusic(java.awt.event.ActionEvent evt) 
    {
        String action = evt.getActionCommand();
        if (action.compareTo("ApproveSelection") == 0)
        {
            try 
            {
                /*wait = true;
                SwingUtilities.invokeLater(new Runnable() 
                {

                    @Override
                    public void run() 
                    {
                        JOptionPane.showMessageDialog(null, "Adding files to Library.\nThis may take a few minutes.", "Started", JOptionPane.INFORMATION_MESSAGE);
                        wait = false;
                    }
                });*/
                file = jFileChooser1.getSelectedFile();
                closeDirChooser();
                importMusic im = new importMusic(mbv,file);
                im.start();
            } 
            catch (Exception e) 
            {//e.printStackTrace();
                mbv.showErrorDialog(e);
            }
        } 
        else 
        {
            closeDirChooser();
        }
    }

    /**
     *
     */
    public void closeDirChooser() 
    {
        dispose();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JDialog jDialog1;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JFrame jFrame1;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
}

class importMusic extends Thread 
{

    private boolean wait;
    private AddFiles addFiles;
    private MusicBoxView mbv;
    private File file;

    public importMusic(MusicBoxView mbv, File file) 
    {
        this.mbv = mbv;
        this.file = file;
    }

    @Override
    @SuppressWarnings({"empty-statement", "empty-statement", "empty-statement"})
    public void run() 
    {
        try 
        {
            mbv.busyIconTimer.start();
            final String dir = file.toString();
            final Statement stmt = mbv.db.getConnection().createStatement();
            if (dir != null) 
            {
                mbv.db.findAudioFiles(file, dir, stmt);
            }
            wait = true;
            //.out.println(mbv.db.getAudioVector().size());
            SwingUtilities.invokeLater(new Runnable() 
            {
                public void run() 
                {
                    addFiles = new AddFiles(mbv.db.getAudioVector().size(),mbv);
                    addFiles.setLocationRelativeTo(null);
                    addFiles.setVisible(true);
                    wait = false;
                }
            });
            while (wait) 
            {
                System.out.print("");
            }
            for (int i = 0; i < mbv.db.getAudioVector().size(); i++) 
            {
                MusicOutputDesign mod = mbv.db.insertMusicFile(mbv.db.getAudioVector().elementAt(i), stmt);
                mbv.allMusic.add(mod);
                if (((CustomTableModel)mbv.currentlyShowingTable.getModel()).getColumnCount() == 0) 
                {
                    for (String columnName: mbv.columnNames) 
                    {
                        ((CustomTableModel)mbv.currentlyShowingTable.getModel()).addColumn(columnName);
                    }
                }
                
                ((CustomTableModel)mbv.currentlyShowingTable.getModel()).addRow(mod, mbv);
                if (addFiles != null && addFiles.isVisible()) 
                {
                    addFiles.getJTextArea().setText("Adding file: " + mbv.db.getAudioVector().elementAt(i).getAbsolutePath());
                    wait = true;
                    SwingUtilities.invokeLater(new Runnable() 
                    {
                        public void run() 
                        {
                            addFiles.getProgressBar().setValue(addFiles.getProgressBar().getValue()+1);
                            wait = false;
                        }
                    });
                    while(wait)
                    {
                        System.out.print("");
                    }
                }
            }
            if(addFiles != null && addFiles.isVisible())
            {
                addFiles.getJButton().setText("Close");
            }
            mbv.db.getAudioVector().clear();
            mbv.db.addPlaylistsToDatabase(stmt);
            stmt.close();
            if(SwingUtilities.isEventDispatchThread())
            {
                ((CustomTableModel)mbv.currentlyShowingTable.getModel()).fireTableDataChanged();
                updateLists();
            }
            else
            {
                SwingUtilities.invokeLater(new Thread()
                {
                    public void run()
                    {
                        ((CustomTableModel)mbv.currentlyShowingTable.getModel()).fireTableDataChanged();
                        updateLists();
                    }
                });
            }
            
            mbv.busyIconTimer.stop();
        } 
        catch (Exception e) 
        {//e.printStackTrace();
            mbv.showErrorDialog(e);
        }
        while (wait)
            System.out.print("");
        new Timer().schedule(new SetLibraryImages(), 100);
    }
    
    public void updateLists()
    {
        DefaultListModel dlm = new DefaultListModel();
            dlm.addElement("(All Artists)");
            try
            {
                Object[] array = mbv.db.selectDistinct(mbv.db.getConnection().createStatement(), "artist");
                for(Object o: array)
                {
                    dlm.addElement(o);
                }
            }
            catch(SQLException ex)
            {
                mbv.showErrorDialog(ex);
            }
            dlm = mbv.sortListModel(dlm);
            mbv.jList1.setModel(dlm);

            DefaultListModel dlm1 = new DefaultListModel();
            dlm1.addElement("(All Albums)");
            try
            {
                Object[] array = mbv.db.selectDistinct(mbv.db.getConnection().createStatement(), "album");
                for(Object o: array)
                {
                    dlm1.addElement(o);
                }
            }
            catch(SQLException ex)
            {
                mbv.showErrorDialog(ex);
            }
            dlm1 = mbv.sortListModel(dlm1);
            mbv.jList2.setModel(dlm1);
    }

    class SetLibraryImages extends TimerTask 
    {
        @Override
        public void run()
        {
            mbv.createAllLibraryArtistPanels();
            mbv.createAllLibraryAlbumPanels();
            try 
            {
                java.sql.Statement stmt = mbv.db.getConnection().createStatement();
                mbv.setAllLibraryArtistImages(stmt);
                mbv.setAllLibraryAlbumImages(stmt);
                stmt.close();
            }
            catch (SQLException ex) 
            {
                //ex.printStackTrace();
                mbv.showErrorDialog(ex);
            }
        }
    }
}
