/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR v PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * FindFile.java
 *
 * Created on Nov 20, 2009, 11:39:24 PM
 */

package musicbox.gui;

import java.io.File;
import javax.swing.filechooser.FileNameExtensionFilter;
import noTalent.MusicOutputDesign;

/**
 *
 * @author Isaac Hammon
 */
public class FindFile extends javax.swing.JDialog 
{
    private MusicOutputDesign oldM;
    private MusicOutputDesign newM;
    private MusicBoxView mbv;
    private int searching = 0;
    /** Creates new form FindFile
     * @param parent
     * @param oldM
     */
    public FindFile(java.awt.Frame parent, MusicOutputDesign oldM, MusicBoxView mbv)
    {
        super(parent);
        this.oldM = oldM;
        newM = (MusicOutputDesign)oldM.clone();
        this.mbv = mbv;
        initComponents();
        this.setIconImage(mbv.musicBoxIcon16.getImage());
    }

    /**
     *
     * @param evt
     */
    public void importMusic(java.awt.event.ActionEvent evt)
    {
        String action = evt.getActionCommand();
        if(action.compareTo("ApproveSelection") == 0)
        {
            File file = jFileChooser1.getSelectedFile();
            newM.setFile(file.getName());
            newM.setFilePath(file.getParent());
            dispose();
            new UpdateTag(oldM, newM, mbv).start();
            searching = 1;
        }
        else
        {
            newM = null;
            searching = -1;
            dispose();
        }
    }
    
    public MusicOutputDesign getNewFile()
    {
       while(searching == 0) 
       {
           System.out.print("");
       }
       return newM;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFileChooser1 = new javax.swing.JFileChooser();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N
        setResizable(false);

        jFileChooser1.setName("jFileChooser1"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jFileChooser1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jFileChooser1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        FileNameExtensionFilter filter = new FileNameExtensionFilter("audio file", "mp3", "wav", "au", "aif", "ogg", "ape", "flac");
        jFileChooser1.setFileFilter(filter);
        jFileChooser1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                importMusic(evt);
            }
        });

        pack();
    }// </editor-fold>//GEN-END:initComponents

    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JFileChooser jFileChooser1;
    // End of variables declaration//GEN-END:variables

}

class UpdateTag extends Thread 
{
    private MusicBoxView mbv;
    private MusicOutputDesign oldM;
    private MusicOutputDesign newM;

    public UpdateTag(MusicOutputDesign oldM, MusicOutputDesign newM, MusicBoxView mbv)
    {
        this.oldM = oldM;
        this.newM = newM;
        this.mbv = mbv;
    }

    @Override
    public void run()
    {
        mbv.busyIconTimer.start();
        try 
        {
            java.sql.Statement stmt = mbv.db.getConnection().createStatement();
            mbv.db.updateTags(stmt, oldM, newM);
            stmt.close();
        } 
        catch (Exception e) 
        {
            //e.printStackTrace();
            mbv.showErrorDialog(e);
        }
        mbv.updateVector(mbv.allMusic, newM, mbv.currentlyShowingTable);
        mbv.busyIconTimer.stop();
        
        Thread.currentThread().stop();
    }
}