/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR v PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package musicbox.gui;

import javax.sound.sampled.FloatControl;
import javax.swing.DefaultBoundedRangeModel;

/**
 *
 * @author Isaac Hammon
 */
public class FloatControlBoundedRangeModel extends DefaultBoundedRangeModel 
{

    private FloatControl control;
    private float steps;

    /**
     *
     * @param control
     */
    public FloatControlBoundedRangeModel(FloatControl control)
    {
        this.control = control;

        float range = 100 - 0;
        float step = range / 1;
        steps = step / range;
        int minimum = (int) (0);
        int maximum = (int) (100);
        int value = (int) ((control.getValue() / control.getMaximum()) * 100);
        setRangeProperties(value, 0, minimum, maximum, false);
    }

    @Override
    public void setValue(int nValue) 
    {
        super.setValue(nValue);
        control.setValue((nValue * control.getMaximum()) / 100);
        //MusicBoxView.jSlider1.setToolTipText("Volume: " + nValue + "%");
    }

    @Override
    public int getValue() 
    {
        return (int) (control.getValue() * getScaleFactor() * 100);
    }

    private float getScaleFactor() 
    {
        return steps;
    }
}
