/*
Music Box
Copyright (C) 2009-2012  Isaac Hammon

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR v PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * MiniPlayer.java
 *
 * Created on Mar 3, 2010, 7:56:27 PM
 */
package musicbox.gui;

import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import musicbox.backend.MusicBoxApp;
import org.jdesktop.application.ResourceMap;

/**
 *
 * @author Isaac Hammon
 */
public class MiniPlayer extends javax.swing.JFrame 
{

    ImageIcon play;
    ImageIcon play1;
    ImageIcon pause;
    ImageIcon pause1;
    ImageIcon next;
    ImageIcon prev;
    private MusicBoxView mbv;

    /** Creates new form MiniPlayer */
    public MiniPlayer(MusicBoxView mbv) 
    {
        ResourceMap rMap = org.jdesktop.application.Application.getInstance(musicbox.backend.MusicBoxApp.class).getContext().getResourceMap(MiniPlayer.class);
        play = rMap.getImageIcon("play");
        play1 = rMap.getImageIcon("play1");
        pause = rMap.getImageIcon("pause");
        pause1 = rMap.getImageIcon("pause1");
        next = rMap.getImageIcon("next");
        prev = rMap.getImageIcon("previous");
        this.mbv = mbv;
        initComponents();
        this.setIconImage(mbv.musicBoxIcon16.getImage());
    }
    
    public void initGraphics()
    { 
        Graphics2D g = (Graphics2D) getGraphics();
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        
        Graphics2D g1 = (Graphics2D) previousButton.getGraphics();
        g1.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        /*Icon i = previousButton.getIcon();
        BufferedImage bi = new BufferedImage(i.getIconWidth(),i.getIconHeight(),BufferedImage.TYPE_INT_RGB);
        ((Graphics2D)bi.getGraphics()).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        ((Graphics2D)bi.getGraphics()).drawImage(((ImageIcon)i).getImage(), 0, 0, null);
        previousButton.setIcon(new ImageIcon(bi));*/
        Graphics2D g2 = (Graphics2D) playButton.getGraphics();
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        Graphics2D g3 = (Graphics2D) nextButton.getGraphics();
        g3.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        ImageIcon i;
        if(mbv.playing)
        {
            i = pause;
        }
        else
        {
            i = play;
        }
        playButton = new PlayButton(i);
        this.setTitle("Music Box Mini");
        previousButton = new PlayButton(prev);
        nextButton = new PlayButton(next);
        jLabel1 = new javax.swing.JLabel();
        jSlider1 = new javax.swing.JSlider();
        jLabel2 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(musicbox.backend.MusicBoxApp.class).getContext().getResourceMap(MiniPlayer.class);
        playButton.setText(resourceMap.getString("playButton.text")); // NOI18N
        playButton.setBorder(null);
        playButton.setName("playButton"); // NOI18N
        playButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                playButtonMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                playButtonMouseExited(evt);
            }
        });
        playButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                playButtonActionPerformed(evt);
            }
        });

        previousButton.setText(resourceMap.getString("previousButton.text")); // NOI18N
        previousButton.setName("previousButton"); // NOI18N
        previousButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                previousButtonMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                previousButtonMouseExited(evt);
            }
        });
        previousButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                previousButtonActionPerformed(evt);
            }
        });

        nextButton.setText(resourceMap.getString("nextButton.text")); // NOI18N
        nextButton.setName("nextButton"); // NOI18N
        nextButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                nextButtonMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                nextButtonMouseExited(evt);
            }
        });
        nextButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextButtonActionPerformed(evt);
            }
        });

        jLabel1.setIcon(resourceMap.getIcon("jLabel1.icon")); // NOI18N
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N
        jLabel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel1MouseClicked(evt);
            }
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jLabel1MouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jLabel1MouseExited(evt);
            }
        });
        jLabel1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                jLabel1MouseMoved(evt);
            }
        });

        jSlider1.setValue(0);
        jSlider1.setName("jSlider1"); // NOI18N
        jSlider1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jSlider1MouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jSlider1MouseExited(evt);
            }
        });
        jSlider1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                jSlider1MouseDragged(evt);
            }
        });

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jTextField1.setEditable(false);
        jTextField1.setText(resourceMap.getString("jTextField1.text")); // NOI18N
        jTextField1.setAutoscrolls(false);
        jTextField1.setName("jTextField1"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 222, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addComponent(previousButton, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(28, 28, 28)
                                .addComponent(playButton, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jSlider1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 190, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(nextButton, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(previousButton, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(nextButton, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(playButton, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jSlider1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(11, 11, 11))
        );

        if(mbv.back.currentLocation == 0)
        previousButton.setEnabled(false);
        mbv.showRating();
        //jSlider1.setForeground(Color.MAGENTA);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void playButtonMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_playButtonMouseEntered
        playButton.setCursor(new Cursor(Cursor.HAND_CURSOR));
        if (mbv.playing == false) 
        {
            playButton.setIcon(play1);
        }
        else 
        {
            if (mbv.pause == false) 
            {
                playButton.setIcon(pause1);
            }
            else 
            {
                playButton.setIcon(play1);
            }
        }

    }//GEN-LAST:event_playButtonMouseEntered

    private void playButtonMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_playButtonMouseExited
        playButton.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        if (mbv.playing == false) 
        {
            playButton.setIcon(play);
        } 
        else 
        {
            if (mbv.pause == false) 
            {
                playButton.setIcon(pause);
            } 
            else 
            {
                playButton.setIcon(play);
            }
        }
    }//GEN-LAST:event_playButtonMouseExited

    private void previousButtonMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_previousButtonMouseEntered
        //jButton1.setIcon(prev);
        previousButton.setCursor(new Cursor(Cursor.HAND_CURSOR));
    }//GEN-LAST:event_previousButtonMouseEntered

    private void previousButtonMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_previousButtonMouseExited
        //jButton1.setIcon(prev);
        previousButton.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }//GEN-LAST:event_previousButtonMouseExited

    private void playButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_playButtonActionPerformed
        if (mbv.playing == false) 
        {
            mbv.playButton.doClick();
            playButton.setIcon(pause);
        } 
        else 
        {
            mbv.pauseButton.doClick();
            playButton.setIcon(play);
        }
    }//GEN-LAST:event_playButtonActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        JFrame mainFrame = MusicBoxApp.getApplication().getMainFrame();
        mainFrame.setVisible(true);
    }//GEN-LAST:event_formWindowClosing

    private void previousButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_previousButtonActionPerformed
        mbv.previousTrackButton.doClick();
    }//GEN-LAST:event_previousButtonActionPerformed

    private void nextButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextButtonActionPerformed
        mbv.nextTrackButton.doClick();
    }//GEN-LAST:event_nextButtonActionPerformed

    private void nextButtonMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_nextButtonMouseEntered
        nextButton.setCursor(new Cursor(Cursor.HAND_CURSOR));
    }//GEN-LAST:event_nextButtonMouseEntered

    private void nextButtonMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_nextButtonMouseExited
        nextButton.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }//GEN-LAST:event_nextButtonMouseExited

    private void jLabel1MouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseMoved
        double x = (double) evt.getX() / (double) jLabel1.getWidth();
        if (x <= 0.2) 
        {
            jLabel1.setIcon(mbv.oneSmile);
        } 
        else if (x > 0.2 && x <= 0.4) 
        {
            jLabel1.setIcon(mbv.twoSmiles);
        } 
        else if (x > 0.4 && x <= 0.6) 
        {
            jLabel1.setIcon(mbv.threeSmiles);
        } 
        else if (x > 0.6 && x <= 0.8) 
        {
            jLabel1.setIcon(mbv.fourSmiles);
        } 
        else if (x > 0.8 && x <= 1.0) 
        {
            jLabel1.setIcon(mbv.fiveSmiles);
        }
    }//GEN-LAST:event_jLabel1MouseMoved

    private void jLabel1MouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseEntered
        jLabel1.setCursor(new Cursor(Cursor.HAND_CURSOR));
    }//GEN-LAST:event_jLabel1MouseEntered

    private void jLabel1MouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseExited
        jLabel1.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        mbv.showRating();
    }//GEN-LAST:event_jLabel1MouseExited

    private void jLabel1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseClicked
        double x = (double) evt.getX() / (double) jLabel1.getWidth();
        if (x <= 0.2) 
        {
            mbv.back.updateRating(mbv.back.currentTrack, 1);
            mbv.showRating();
        } 
        else if (x > 0.2 && x <= 0.4) 
        {
            mbv.back.updateRating(mbv.back.currentTrack, 2);
            mbv.showRating();
        } 
        else if (x > 0.4 && x <= 0.6) 
        {
            mbv.back.updateRating(mbv.back.currentTrack, 3);
            mbv.showRating();
        }
        else if (x > 0.6 && x <= 0.8) 
        {
            mbv.back.updateRating(mbv.back.currentTrack, 4);
            mbv.showRating();
        } 
        else if (x > 0.8 && x <= 1.0) 
        {
            mbv.back.updateRating(mbv.back.currentTrack, 5);
            mbv.showRating();
        }
    }//GEN-LAST:event_jLabel1MouseClicked

    private void jSlider1MouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jSlider1MouseDragged
        try 
        {
            mbv.finalPercent = (double)jSlider1.getValue()/100;
            double f = mbv.finalPercent*100;
            mbv.timeSkipped = mbv.finalPercent * (double) mbv.trackLength;
            long finalP = (long) f;
            long newPos = (long) Math.round((mbv.back.fileLength * finalP) / 100);
            mbv.back.doSeek = newPos;
            mbv.back.toSkip = newPos;
            mbv.changed = (int) f;
        } 
        catch (Exception ex) 
        {
            //ex.printStackTrace();
            mbv.showErrorDialog(ex);
        }
    }//GEN-LAST:event_jSlider1MouseDragged

    private void jSlider1MouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jSlider1MouseEntered
        jSlider1.setCursor(new Cursor(Cursor.HAND_CURSOR));
    }//GEN-LAST:event_jSlider1MouseEntered

    private void jSlider1MouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jSlider1MouseExited
        jSlider1.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }//GEN-LAST:event_jSlider1MouseExited

    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JLabel jLabel1;
    public javax.swing.JLabel jLabel2;
    public javax.swing.JSlider jSlider1;
    public javax.swing.JTextField jTextField1;
    public javax.swing.JButton nextButton;
    private javax.swing.JButton playButton;
    public javax.swing.JButton previousButton;
    // End of variables declaration//GEN-END:variables
}

class PlayButton extends JButton 
{
    public PlayButton(Icon ico) 
    {
        setPreferredSize(new Dimension(70, 70));
        setContentAreaFilled(false);
        setBorderPainted(false);
        setIcon(ico);
    }
}
