/*
    Music Box
    Copyright (C) 2009-2012  Isaac Hammon

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    */

/*
 * SongSplash.java
 *
 * Created on Oct 5, 2009, 11:43:18 PM
 */

/**
 *
 * @author Isaac Hammon
 */
package musicbox.gui;

import java.awt.Dimension;
import java.awt.EventQueue;
import java.lang.reflect.InvocationTargetException;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.JDialog;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;
import javax.swing.text.StyledDocument;
import noTalent.MusicOutputDesign;

/**
 *
 * @author Isaac Hammon
 */
public class SongSplash extends javax.swing.JDialog 
{
    private MusicOutputDesign m;
    private MusicBoxView mbv;
    /** Creates new form SongSplash
     * @param parent
     * @param m
     */
    public SongSplash(java.awt.Frame parent, MusicOutputDesign m, MusicBoxView mbv) 
    {
        super(parent);
        this.m = m;
        this.mbv = mbv;
        initComponents();
        setIconImage(mbv.musicBoxIcon16.getImage());
    }
    
    public void disposeSongSplash()
    {
        Timer t = new Timer();
        t.schedule(new Dispose(this), 5000);
    }
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setAlwaysOnTop(true);
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setName("Form"); // NOI18N
        setResizable(false);
        setUndecorated(true);

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jTextPane1.setEditable(false);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(musicbox.backend.MusicBoxApp.class).getContext().getResourceMap(SongSplash.class);
        jTextPane1.setFont(resourceMap.getFont("jTextPane1.font")); // NOI18N
        jTextPane1.setFocusCycleRoot(false);
        jTextPane1.setName("jTextPane1"); // NOI18N
        StyleContext sc = new StyleContext();
        StyledDocument doc = jTextPane1.getStyledDocument();
        MutableAttributeSet standard = new SimpleAttributeSet();
        StyleConstants.setAlignment(standard, StyleConstants.ALIGN_CENTER);
        StyleConstants.setFontFamily(standard, "Alba Super");
        StyleConstants.setFontSize(standard, 18);
        doc.setParagraphAttributes(0, 0, standard, true);
        String str = m.getTrackTitle()
        + "\nBy: " + m.getArtist()
        + "\nAlbum: " + m.getAlbum();
        jTextPane1.setText(str);
        jTextPane1.setDocument(doc);
        jScrollPane1.setViewportView(jTextPane1);
        setSize(new Dimension(689, 162));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 689, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 104, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextPane jTextPane1;
    // End of variables declaration//GEN-END:variables
 class Dispose extends TimerTask 
 {
     JDialog jd;
     
     public Dispose(JDialog jd)
     {
         this.jd = jd;
     }
     
    @Override
    public void run() 
    {
        while(jd == null)
        {
            System.out.print("");
        }
        while(!jd.isVisible())
        {
            System.out.print("");
        }
        if(EventQueue.isDispatchThread())
        {
            jd.setVisible(false);
        }
        else
        {
            try 
            {
                EventQueue.invokeAndWait(new Thread()
                {
                    @Override
                    public void run() 
                    {
                        jd.setVisible(false);
                    }
                });
            }
            catch (InterruptedException ex) 
            {
                mbv.showErrorDialog(ex);
            }
            catch (InvocationTargetException ex) 
            {
                mbv.showErrorDialog(ex);
            }
        }
    }
 }
}
